/* Sdals Favourite Map Switch v03.07.03
 
 * Anwendung:
 * Wenn keine Spieler auf dem Server sind, wird direkt zur Favourite Map gewechselt.
 * Wenn wir uns schon auf der Favourite Map befinden, wird das timelimit auf 0 gesetzt, bis wieder ein Spieler connected.
 * Die berprfung findet 90 Sekunden nach Laden der Map statt, sowie bei Connect/Disconnect eines Spielers.
 *
 
*/
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072

new STRING_VERSION[MAX_DATA_LENGTH]="03.07.03";

new g_FavouriteMap[MAX_NAME_LENGTH];

new g_origTimelimit;
new g_Set_Timelimit=0;

public plugin_connect(HLUserName,HLIP, UserIndex) {
	set_timer("check_map",10,0);
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	set_timer("check_map",10,0);
	return PLUGIN_CONTINUE;
}

public check_map(Timer,Repeat,HLName,HLParam){
	new Text[MAX_TEXT_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new players=playercount();
	
	currentmap(Map,MAX_NAME_LENGTH);
	
	if(players==0){
		if(strcmp(g_FavouriteMap,Map)==0){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-CYCLE] %s wird dauerhaft gespielt, bis Spieler connecten!",g_FavouriteMap);
			setstrvar("mp_timelimit","0");
			g_Set_Timelimit=0;
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-CYCLE] Es wird zu %s gewechselt, da keine Spieler anwesend sind!",g_FavouriteMap);
			changelevel( g_FavouriteMap, 3);
		}
		say(Text);
	}else{
		if(g_Set_Timelimit==0){
			new sTimelimit[MAX_NUMBER_LENGTH];
			g_Set_Timelimit=1;
			numtostr(g_origTimelimit,sTimelimit);
			setstrvar("sv_restart","1");
			setstrvar("mp_timelimit",sTimelimit);
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-CYCLE] Spieler anwesend! Timelimit auf %s Min. gesetzt!",sTimelimit);
			say(Text);
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	new Text[MAX_TEXT_LENGTH];
	get_vaultdata("FAVOURITE_MAP", g_FavouriteMap,MAX_NAME_LENGTH);
	if(strlen(g_FavouriteMap)==0){
		strcpy(g_FavouriteMap,"de_dust",MAX_NAME_LENGTH);
		set_vaultdata("FAVOURITE_MAP","de_dust");
	}
	snprintf(Text,MAX_TEXT_LENGTH,"Bei zu wenigen Spielern, wird zu %s gewechselt.",g_FavouriteMap);
	plugin_registerinfo("Favourite Map Switch",Text,STRING_VERSION);
	g_origTimelimit= getvar("mp_timelimit");
	set_timer("check_map",90,0);
	return PLUGIN_CONTINUE;
}